<template>
  <div>
    <v-row>
      <v-col cols="1">
        <v-text-field value="INTERNET" label="SERVICE" disabled/>
      </v-col>
      <v-col cols="1" v-if="vendor === 'FH' && open_ont === 1">
        <v-btn @click="add">Add WAN</v-btn>
      </v-col>
      <v-col cols="1" v-if="vendor === 'ZTE'">
        <v-text-field type="number" v-model="inet.vport" :disabled="disabled" label="VPORT"/>
      </v-col>
    </v-row>
    <v-row
        v-for="(data, i) in inet.data"
        :key="'inet' + i"
    >
      <v-col cols="2" align="center" v-if="vendor === 'FH' && open_ont === 1">
        <v-btn @click="remove(i)">Remove</v-btn>
      </v-col>
      <v-col cols="1">
        <v-text-field type="number" v-model="data.vlan" :disabled="disabled" label="VLAN"/>
      </v-col>
      <v-col cols="1" v-if="vendor === 'FH' && open_ont === 1 && status === 1">
        <v-text-field type="number" v-model="data.qos" :disabled="disabled" label="QOS"/>
      </v-col>
      <v-card-actions>
        <div v-for="lan in 4" :key="lan">
          <v-checkbox
              v-if="vendor === 'FH' && open_ont === 1 && status === 1"
              :disabled="disabled"
              v-model="data.lan"
              :label="`LAN ${lan}`"
              :value="lan"
              class="shrink mr-2 mt-0"
          />
        </div>
        <div v-for="ssid in 4" :key="'ssid' + ssid">
          <v-checkbox
              v-if="vendor === 'FH' && open_ont === 1 && status === 1"
              :disabled="disabled"
              v-model="data.ssid"
              :label="`SSID ${ssid}`"
              :value="ssid"
              class="shrink mr-2 mt-0"
          />
        </div>
        <div v-for="ssid in 4" :key="'ssid' + ssid + 4">
          <v-checkbox
              v-if="vendor === 'FH' && onu_type === 'HG6145F' && open_ont === 1 && status === 1"
              :disabled="disabled"
              v-model="data.ssid"
              :label="`SSID 5G ${ssid}`"
              :value="ssid + 4"
              class="shrink mr-2 mt-0"
          />
        </div>
      </v-card-actions>
      <v-col cols="2" v-if="vendor === 'FH' && open_ont === 1">
        <v-select
            :disabled="disabled"
            v-model="data.mode"
            :items="wan_modes"
            item-text="name"
            item-value="id"
            label="Pilih WAN"
            @change="doChangeMode(i)"
        />
      </v-col>
      <v-col cols="2" v-if="vendor === 'FH' && open_ont === 1">
        <v-select
            :disabled="disabled || data.disabledWan"
            v-model="data.conn_type"
            :items="conn_types"
            item-text="name"
            item-value="id"
            label="Pilih Tipe"
            @change="doChangeConnType(i)"
        />
      </v-col>
      <v-col cols="2" v-if="vendor === 'FH' && data.conn_type === 2 && open_ont === 1 && status === 1">
        <v-select
            :disabled="disabled"
            v-model="data.ip_mode"
            :items="ip_modes"
            item-text="name"
            item-value="id"
            label="Pilih IP MODE"
            @change="doChangeIpMode(i)"
        />
      </v-col>
      <v-col cols="2" v-if="data.conn_type === 2 && data.ip_mode === 3 && open_ont === 1 && status === 1">
        <v-text-field v-model="data.acc" clearable :disabled="disabled" label="ACCOUNT"/>
      </v-col>
      <v-col cols="2" v-if="data.conn_type === 2 && data.ip_mode === 3 && open_ont === 1 && status === 1">
        <v-text-field v-model="data.pwd" clearable :disabled="disabled" label="PASSWORD"/>
      </v-col>
      <v-col cols="2" v-if="status === 1">
        <v-text-field v-model="data.bw_up" clearable :disabled="disabled" label="UPLOAD"/>
      </v-col>
      <v-col cols="2" v-if="status === 1">
        <v-text-field v-model="data.bw_down" clearable :disabled="disabled" label="DOWNLOAD"/>
      </v-col>
    </v-row>
  </div>
</template>

<script>
export default {
  name: "InetForm",
  props: ['inet', 'vendor', 'disabled', 'onu_type', 'open_ont', 'status'],
  data: () => ({
    wan_modes: [
      { id: 1, name: 'TR069' },
      { id: 2, name: 'INTERNET' },
      { id: 3, name: 'TR069_INTERNET' },
      { id: 4, name: 'multicast' },
      { id: 5, name: 'VOIP' },
      { id: 6, name: 'VOIP_INTERNET' },
      { id: 7, name: 'IPTV' },
      { id: 8, name: 'RADIUS' },
      { id: 9, name: 'RADIUS_INTERNET' },
      { id: 10, name: 'TR069_VOIP_INTERNET' },
      { id: 11, name: 'OTHER' },
    ],
    conn_types: [
      { id: 1, name: 'BRIDGE' },
      { id: 2, name: 'ROUTE' },
    ],
    ip_modes: [
      { id: 1, name: 'DHCP' },
      { id: 3, name: 'PPPOE' },
    ]
  }),
  methods: {
    add() {
      let lan = [1]
      if (this.onu_type === 'HG6145F') {
        lan = [1, 5]
      }

      let qos = 0;
      for (let data of this.inet.data) {
        if (qos < 7) {
          qos = data.qos + 1
        } else {
          qos = 0
        }
      }

      this.inet.data.push({
        mode: 2,
        conn_type: 2,
        ip_mode: 3,
        vlan: 1,
        acc: null,
        pwd: null,
        qos: qos,
        lan: lan,
        ssid: [1],
        bw_up: null,
        bw_down: null,
        disabledWan: false,
      })
    },
    remove(index) {
      this.inet.data.splice(index, 1)
    },
    doChangeMode(index) {
      let inet = this.inet.data[index]
      let mode = inet.mode
      inet.disabledWan = false
      if (mode === 1 || mode === 3 || mode === 6 || mode === 8 || mode === 9 || mode === 10) {
        inet.conn_type = 2
        inet.disabledWan = true
      }
    },
    doChangeConnType(index) {
      let inet = this.inet.data[index]
      let conn_type = inet.conn_type
      if (conn_type === 1) {
        inet.acc = null
        inet.pwd = null
      }
    },
    doChangeIpMode(index) {
      let inet = this.inet.data[index]
      let ip_mode = inet.ip_mode
      if (ip_mode === 1) {
        inet.acc = null
        inet.pwd = null
      }
    }
  }
}
</script>

<style scoped>

</style>